#include "forms.h"
#include "html.h"


/**** Forms and Objects ****/

typedef struct {
	FL_FORM *htmltest;
	FL_OBJECT *htmlbox;
	FL_OBJECT *scrollbar;
	FL_OBJECT *wordfield;
	FL_OBJECT *linkfield;
	void *vdata;
	long ldata;
} FD_htmltest;

extern FD_htmltest * create_form_htmltest(void);

void exit_cb(FL_OBJECT *ob, long data)
{
  exit(0);
}

FD_htmltest *create_form_htmltest(void)
{
  FL_OBJECT *obj;
  FD_htmltest *fdui = (FD_htmltest *) fl_calloc(1, sizeof(FD_htmltest));

  fdui->htmltest = fl_bgn_form(FL_NO_BOX, 470, 400);
  obj = fl_add_box(FL_UP_BOX,0,0,470,400,"");
  fdui->htmlbox = obj = fl_add_html(FL_NORMAL_HTML,10,60,420,290,"");
  obj = fl_add_button(FL_NORMAL_BUTTON,10,10,450,40,"QUIT");
    fl_set_object_lcol(obj,FL_RED);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,exit_cb,0);
  fdui->scrollbar = obj = fl_add_slider(FL_VERT_SLIDER,430,60,30,290,"");
    fl_set_object_callback(obj,exit_cb,0);
  fdui->wordfield = obj = fl_add_text(FL_NORMAL_TEXT,10,360,170,30,"");
    fl_set_object_boxtype(obj,FL_FRAME_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
  fdui->linkfield = obj = fl_add_text(FL_NORMAL_TEXT,190,360,270,30,"");
    fl_set_object_boxtype(obj,FL_FRAME_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
  fl_end_form();

  return fdui;
}
/*---------------------------------------*/


int main(int argc, char *argv[])
{
	FD_htmltest *fd_htmltest;

   fl_initialize(argv[0], 0, 0, 0, &argc, argv);
   fd_htmltest = create_form_htmltest();

   /* fill-in form initialization code */
	fl_html_set_text(fd_htmltest->htmlbox,NULL,0);
	fl_html_set_scrollbar(fd_htmltest->htmlbox,fd_htmltest->scrollbar);
	/*fl_html_redraw(fd_htmltest->htmlbox);*/

	if(argc == 2) {
		FILE *fp = fopen(argv[1],"r");
		char buffer[1024];
		while(fgets(buffer,1023,fp)) {
			fl_html_add_line(fd_htmltest->htmlbox,buffer);
		}
		fclose(fp);
	} else {
		fprintf(stderr,"Usage: %s html-file\n",argv[0]);
		exit(0);
	}

   fl_show_form(fd_htmltest->htmltest,FL_PLACE_CENTER,FL_FULLBORDER,"htmltest");
	
	while(1 == 1) {
		FL_OBJECT *obj = fl_do_forms();
		if(obj == fd_htmltest->htmlbox) {
			const char *anchor = fl_html_get_link(obj);
			const char *word = fl_html_get_word(obj);
			if(anchor) {
				fl_set_object_label(fd_htmltest->linkfield,anchor);
			} else fl_set_object_label(fd_htmltest->linkfield,"<none>");
			if(word) {
				fl_set_object_label(fd_htmltest->wordfield,word);
			} else fl_set_object_label(fd_htmltest->wordfield,"<none>");
			if(anchor && anchor[0] == '#') fl_html_jmp_anchor(obj,anchor+1);
		}
	}
   return 0;
}
