/*
 * HTML-object for the XForms library --- initial release, 0.1
 *
 * Copyright (C) 1996 Oliver Jakobs
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author can be contacted via email at O.Jakobs@bham.ac.uk
 * or at http://www-clg.bham.ac.uk/oliver
 *
 */

#ifndef _HTML_H_
#define _HTML_H_

#include <stdio.h>
#include "forms.h"

#define FL_HTML			1996		/* or whatever */
#define FL_NORMAL_HTML	0			/* normal style */
#define FL_PASSIVE_HTML	1			/* no links */


extern FL_OBJECT *fl_create_html(int, FL_Coord, FL_Coord, FL_Coord, FL_Coord,
		const char *);
extern FL_OBJECT *fl_add_html(int, FL_Coord, FL_Coord, FL_Coord, FL_Coord,
		const char *);

extern int fl_html_set_text(FL_OBJECT *ob, char **text, int width);
extern int fl_html_add_line(FL_OBJECT *ob, char *line);
extern const char *fl_html_get_word(FL_OBJECT *ob);
extern const char *fl_html_get_link(FL_OBJECT *ob);
extern void fl_html_pg(FL_OBJECT *ob, int dir);
extern void fl_html_scroll(FL_OBJECT *ob, int dir);
extern int fl_html_set_scrollbar( FL_OBJECT *ob, FL_OBJECT *sbar);
extern int fl_html_jmp(FL_OBJECT *ob, int percentage);
extern int fl_html_jmp_anchor(FL_OBJECT *ob, const char *name);

#endif
