/*
 * html object for XForms
 * (C) Oliver Jakobs, 1996
 */

#include "html.h"

typedef struct _wrd {
	int x;				/* indent */
	int y;				/* relative to 0,0 */
	int w;				/* width */
	int h;				/* height */
	int col;			/* colour */
	int size;			/* fontsize */
	int style;			/* fontstyle */
	char *word;			/* the word */
	char *link;			/* a hypertext link */
	struct _wrd *next;	/* the next word */
} WordT;

typedef struct _anc {
	char *name;
	int yval;
	struct _anc *next;
} AnchorT;

typedef struct _info {
	int x;
	int y;
	int indent;
	int width;
	int colour;
	int fsize;
	int fstyle;
	int env;
	int counter;
	int align;
	struct _info *next;
} InfoT;

typedef struct {
	int height;
	int topline;
	int fontsize;
	int fontstyle;
	AnchorT *anchors;
	InfoT *stack;
	WordT *data;
	InfoT *p_info;
	WordT *p_currentline;
	char *p_url;
	int p_x;
	int p_y;
	char *lastword;
	char *lastlink;
	int highlight;
	FL_OBJECT *sbar;
} HtmlspecT;

	

typedef struct {
	char *name;
	int command;
	int linebreaks;
} CommandT;
